package org.netkernel.layer1.endpoint;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IHDSIndex;
import org.netkernel.layer0.representation.IHDSIndexSpecification;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.impl.HDSIndex;
import org.netkernel.layer0.representation.impl.HDSIndexSpecificationFactory;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class HDSIndexAccessor extends StandardAccessorImpl
{
	public HDSIndexAccessor()
	{	declareThreadSafe();
	}
	
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		IHDSNode operand=aContext.source("arg:operand",IHDSNode.class);
		IHDSIndexSpecification operator;
		if (aContext.getThisRequest().argumentExists("operator"))
		{	operator=aContext.source("arg:operator",IHDSIndexSpecification.class);
		}
		else
		{	//default to indexing everything by value (as per IHDSInversion legacy)
			operator=HDSIndexSpecificationFactory.INDEX_ALL_BY_VALUE;
		}
		
		IHDSIndex index = new HDSIndex(operand,operator);
		aContext.createResponseFrom(index);
	}
}
