/******************************************************************************
 * (c) Copyright 2002,2003, 1060 Research Ltd
 *
 * This Software is licensed to You, the licensee, for use under the terms of
 * the 1060 Public License v1.0. Please read and agree to the 1060 Public
 * License v1.0 [www.1060research.com/license] before using or redistributing
 * this software.
 *
 * In summary the 1060 Public license has the following conditions.
 * A. You may use the Software free of charge provided you agree to the terms
 * laid out in the 1060 Public License v1.0
 * B. You are only permitted to use the Software with components or applications
 * that provide you with OSI Certified Open Source Code [www.opensource.org], or
 * for which licensing has been approved by 1060 Research Limited.
 * You may write your own software for execution by this Software provided any
 * distribution of your software with this Software complies with terms set out
 * in section 2 of the 1060 Public License v1.0
 * C. You may redistribute the Software provided you comply with the terms of
 * the 1060 Public License v1.0 and that no warranty is implied or given.
 * D. If you find you are unable to comply with this license you may seek to
 * obtain an alternative license from 1060 Research Limited by contacting
 * license@1060research.com or by visiting www.1060research.com
 *
 * NO WARRANTY:  THIS SOFTWARE IS NOT COVERED BY ANY WARRANTY. SEE 1060 PUBLIC
 * LICENSE V1.0 FOR DETAILS
 *
 * THIS COPYRIGHT NOTICE IS *NOT* THE 1060 PUBLIC LICENSE v1.0. PLEASE READ
 * THE DISTRIBUTED 1060_Public_License.txt OR www.1060research.com/license
 *
 * File:          $RCSfile: ExecProcessStderrAspect.java,v $
 * Version:       $Name:  $ $Revision: 1.2 $
 * Last Modified: $Date: 2004/09/02 14:01:38 $
 *****************************************************************************/
package org.netkernel.layer1.endpoint.exec;

import java.io.*;

import org.netkernel.layer0.representation.IBinaryStreamRepresentation;
import org.netkernel.layer0.util.Utils;
/**
 * An IAspectReadableBinaryStream created from the stderr of an exec-ed process.
 * The aspect can only be used once and it has an inderminate length
 * @author  tab
 */
public class ExecProcessStderrAspect implements IBinaryStreamRepresentation
{
	private InputStream mStream;
	
	/** Creates a new instance of ExecProcessStderrAspect */
	public ExecProcessStderrAspect(InputStream aStream)
	{	mStream = aStream;
	}
	
	public String getEncoding()
	{	return null;
	}
	
	public int getContentLength()
	{	return -1;
	}	
	
	public InputStream getInputStream() throws IOException
	{	if (mStream!=null)
		{	InputStream result = mStream;
			mStream=null;
			return result;
		}
		else
		{	throw new IOException("ExecProcessStderrAspect can only be used once");
		}
	}
	
	public void write(OutputStream aStream) throws IOException
	{	if (mStream!=null)
		{	Utils.pipe(mStream,aStream);
			mStream=null;
		}
		else
		{	throw new IOException("ExecProcessStderrAspect can only be used once");
		}
	}
}