package org.netkernel.layer1.endpoint.hds;

import java.util.ArrayList;
import java.util.List;

import org.netkernel.container.IKernel;
import org.netkernel.layer0.meta.impl.SourcedArgumentMetaImpl;
import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.IHDSNodeList;
import org.netkernel.layer0.representation.impl.HDSNodeListImpl;
import org.netkernel.layer0.urii.ValueSpace;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class HDSFilterAccessor extends StandardAccessorImpl
{
	public HDSFilterAccessor()
	{	this.declareThreadSafe();
		this.declareSourceRepresentation(IHDSNodeList.class);
		this.declareArgument(new SourcedArgumentMetaImpl("operand",null,null,new Class[] {IHDSNodeList.class}));
		this.declareArgument(new SourcedArgumentMetaImpl("cond",null,null,new Class[] {Boolean.class}));
	}
	
	public void onSource(INKFRequestContext aContext) throws Exception
	{	IHDSNodeList operand=aContext.source("arg:operand",IHDSNodeList.class);
		IKernel k=aContext.getKernelContext().getKernel();
		List<IHDSNode> nodes=new ArrayList<IHDSNode>(operand.size());
		for (IHDSNode node: operand)
		{
			INKFRequest req=aContext.createRequest("arg:cond");
			ValueSpace values=new ValueSpace(3);
			values.put("hdsfilter:node", node, null);
			values.onCommissionSpace(k);
			req.injectDurableRequestScope(values);
			req.setRepresentationClass(Boolean.class);
			boolean cond=(Boolean)aContext.issueRequest(req);
			if (cond)
			{	nodes.add(node);
			}
		}
		HDSNodeListImpl result=new HDSNodeListImpl(nodes);
		aContext.createResponseFrom(result);
	}
}
