package org.netkernel.layer1.endpoint.hds;

import org.netkernel.container.IKernel;
import org.netkernel.layer0.meta.impl.SourcedArgumentMetaImpl;
import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IHDSIndex;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.IHDSNodeList;
import org.netkernel.layer0.representation.impl.HDSIndex;
import org.netkernel.layer0.urii.ValueSpace;
import org.netkernel.layer0.util.MultiMap;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class HDSIndex2Accessor extends StandardAccessorImpl
{
	public HDSIndex2Accessor()
	{	this.declareThreadSafe();
		this.declareSourceRepresentation(IHDSIndex.class);
		this.declareArgument(new SourcedArgumentMetaImpl("operand",null,null,new Class[] {IHDSNodeList.class}));
		this.declareArgument(new SourcedArgumentMetaImpl("key",null,null,new Class[] {Object.class}));
	}

	public void onSource(INKFRequestContext aContext) throws Exception
	{	IHDSNodeList operand=aContext.source("arg:operand",IHDSNodeList.class);
		IKernel k=aContext.getKernelContext().getKernel();
		MultiMap map=new MultiMap(operand.size(), 4);
		for (IHDSNode node: operand)
		{
			INKFRequest req=aContext.createRequest("arg:key");
			ValueSpace values=new ValueSpace(3);
			values.put("hdsindex:node", node, null);
			values.onCommissionSpace(k);
			req.injectDurableRequestScope(values);
			Object key=aContext.issueRequest(req);
			map.put(key,node);
		}
		HDSIndex result=new HDSIndex(map);
		aContext.createResponseFrom(result);
	}
}
